package sample.web1.security;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import org.springframework.jdbc.core.RowMapper;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.AuthorityUtils;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.jdbc.JdbcDaoImpl;

/**
 * MyUserɑΉUserDetailsServiceNX
 * Spring SecurityftHgŒ񋟂RDBMS̏擾JdbcDaoImplgĂB
 */
public class MyUserDetailsService extends JdbcDaoImpl {

    @Override
    protected List<UserDetails> loadUsersByUsername(String username) {
        return getJdbcTemplate().query(getUsersByUsernameQuery(), new String[] { username },
                new RowMapper<UserDetails>() {
                    public UserDetails mapRow(ResultSet rs, int rowNum) throws SQLException {
                        String username = rs.getString(1);
                        String password = rs.getString(2);
                        boolean enabled = rs.getBoolean(3);
                        String company = rs.getString(4);
                        String division = rs.getString(5);
                        return new MyUser(username, password, company, division, enabled, true, true, true,
                                AuthorityUtils.NO_AUTHORITIES);
                    }

                });
    }

    @Override
    protected UserDetails createUserDetails(String username, UserDetails userFromUserQuery,
            List<GrantedAuthority> combinedAuthorities) {
        UserDetails user = super.createUserDetails(username, userFromUserQuery, combinedAuthorities);

        if (userFromUserQuery instanceof MyUser) {
            MyUser myUser = (MyUser) userFromUserQuery;
            return new MyUser(user.getUsername(), user.getPassword(), myUser.getCompanyName(),
                    myUser.getDivisionName(), user.isEnabled(), user.isAccountNonExpired(), user
                            .isCredentialsNonExpired(), user.isAccountNonLocked(), user.getAuthorities());
        } else {
            return user;
        }
    }

}
